function [SKM,counters]=reg_SKM_smo2(SKM0,train,Y,C,d,regu,acc,dkb,counters,option);
global DKDa aDKDa K_stack I;

%%% Init problem variables;
n = length(Y);     % number of datapoints
N=size(K_stack,2);
m = size(K_stack,1)/N;   % number of kernels currently non-zeros
if isempty(SKM0),
    old_alphas = zeros(n,1);
    DKDa = zeros(n,m);              % array of the dual variables for w_j
    aDKDa = zeros(m,1);             % list of the dual variables for norm(w_j)^2
else
    old_alphas=SKM0.alphas;
    etas_tilde_here=SKM0.etas_tilde;
    
    %% We assume that at this point DKDa and aDKDa have been updated
end
new_alphas = zeros(n,1);
eps1_here=Inf;
eps2_here=Inf;
bias=0;

if min(Y)==1;
    error('There is no negative example');
end

if max(Y)==-1;
   error('There is no postive example');
end 

%%% Unreg stagnation parameters
nb_steps=100;
refract0=400;

%%%Flags
over_maxiter=0;
toosmall=0;

%%% History storing
if option.store_history,
    Gas = [];                                   %objective function values
    obj=[];
    obj_ub=[];
    obj_lb=[];
    cost=[];
    step_loss=[];
    taus = [];
    eps1s = [];
    eps2s = [];
    weights_evol = [];
    a_evol=[];
    I_M_evol=[];
end

if option.use_svm,
    pos=find(Y==1);
    neg=find(Y==-1);
    option.Cp=C(pos(1));
    option.Cn=C(neg(1));
end
if m==1,
    option.svm=1;
    regu.value=0;
    regu.iter_max=1;
else
    option.svm=0;
end

%%% Init etas from new (a,d)
a=regu.value*ones(m,1);
if option.svm,
    Ga0=aDKDa;
    etas=1;
    etas_tilde_here=1;
else
    [Ga0,etas] = skmreg(d,a,aDKDa);
end

Ga=Ga0-sum(new_alphas);
unreg_optimal=0;
switch_to_svm=0;
switched_to_SVM=0;

%%% Go!
%try
    skm_smo_loop2;
%catch
%    [lstmsg, lstid]=lasterr;
%    if strcmp(lstid,'SKMsmo:skmreg:toosmall');
%        toosmall=1;
%        disp('catch!');
%    else
%        rethrow(lasterror)
%    end
%end


%%% Results
    bias=-(bl2+bu2)/2;
  obj_curr=0.5*etas_tilde_here'*aDKDa-sum(new_alphas);
  obj_ub_curr=0.5*max(aDKDa)-sum(new_alphas);
  if obj_curr>obj_ub_curr+1e-8,
      warning('obj_curr>obj_ub_curr');
  end
   kkt=-g2-Y*bias;
  obj_lb_curr=-0.5*max(aDKDa)-C'*max(kkt,0);
SKM.etas = etas;
if switched_to_SVM,
SKM.etas_tilde=SKM_saved.etas_tilde;
K_stack=SKM_saved.K_stack;
m=length(SKM.etas_tilde);
Kzoo=reshape(K_stack(:,train)*(new_alphas.*Y),N,m);
DKDa=repmat(Y,1,m).*Kzoo(train,:);
aDKDa=(new_alphas'*DKDa)';
else
SKM.etas_tilde=etas_tilde_here;
end
SKM.alphas = new_alphas;
SKM.bias=bias;
SKM.eps1=eps1_here;
SKM.eps2=eps2_here;
SKM.tau=tau_here;
SKM.nb_iter=counters.global;
SKM.Y=Y;
SKM.duality_gap=obj_ub_curr-obj_lb_curr;
SKM.discrim=Y.*(g2+1)+bias;

if option.store_history,
    SKM.Gas=Gas;
    SKM.obj=obj;
    SKM.obj_ub=obj_ub;
    SKM.obj_lb=obj_lb;
    SKM.step_loss=step_loss;
    SKM.cost=cost;
    SKM.taus=taus;
    SKM.eps1s=eps1s;
    SKM.eps2s=eps2s;
    SKM.weights_evol=weights_evol;
    SKM.a_evol=a_evol;
    SKM.I_M_evol=I_M_evol;    
end

outflags.over_maxiter=over_maxiter; %% The maximal number of iteration has been reached
outflags.reg_optimal=optimal;       %% The solution is optimal for the regularization chosen
outflags.unreg_optimal=(eps1_here<acc.tau1 & eps2_here<acc.tau2); %% The solution is optimal for the unregularized problem
outflags.unreg_stagnant=eps_i_unchanged; %% The solution is the best obtainable for the unreg problem at this reg level
outflags.alphas_stagnant=all_alpha_unchanged | alpha_unchanged; %% The alphas are changing too slowly
outflags.toosmall=toosmall;

SKM.outflags=outflags;
%keyboard;
